/**
 * This class contains unit tests for validating the behavior of Apex classes
 * and triggers.
 *
 * Unit tests are class methods that verify whether a particular piece
 * of code is working properly. Unit test methods take no arguments,
 * commit no data to the database, and are flagged with the testMethod
 * keyword in the method definition.
 *
 * All test methods in an organization are executed whenever Apex code is deployed
 * to a production organization to confirm correctness, ensure code
 * coverage, and prevent regressions. All Apex classes are
 * required to have at least 75% code coverage in order to be deployed
 * to a production organization. In addition, all triggers must have some code coverage.
 * 
 * The @isTest class annotation indicates this class only contains test
 * methods. Classes defined with the @isTest annotation do not count against
 * the organization size limit for all Apex scripts.
 *
 * See the Apex Language Reference for more information about Testing and Code Coverage.
 */
@isTest
private class GRD_XmlWriterTest {
    public class Borehole
    {
        public String id;
        public String name;
        public String status;
        public String grdGuid;
        public String wellviewBoreGuid;
        public String wellviewBoreGuidMappingGUID; // this is the GUID from the T_MASTER_DATA_MAPPING table
        public String wellClass;
        public String targetFormation;
        public String wellType;
        public String wellCategory;
        public String geologist;
        //Location Information
        public String operatingField;
        public String operatingFieldId;
        public String surfaceLocation; 
        public String surfaceLocId;
        public String targetLocation;
        public String targetLocId;
        public String uwiLocation;
        public String uwiLocId;
        public Decimal measuredDepth;
        public Decimal horizontalLength;
        public Decimal workingInterest;
        public Decimal trueVerticalDepth;
        public String opNonOp;
        public String strategy;
        public String pool;
        public String primaryProduct;
        public Decimal risk;
        
        public Integer noOfCompletions;
        //associated well is uwi location which allows multiple bores to be associated to a well
        public String associatedWell;
        //if there is an error while saving to database, this flag is checked by Mule
        public String errorInDb;
        // Flag is true while DB is updating record
        public String refreshingFromDB;
        
        public List<Completion> completions;
        
        public List<GUIDMapping> GUIDMappings;
        public String AMUGUID;   
    }
    
    public class Completion
    {
        public String id;
        public String name;
        public String completionGuid;
        //Decimal completionId;
        public String categoryIsolation;
        public String completionFluid;
        public Decimal numberOfStages;
        public Decimal sizeOfStages;
        public String proppantSize;
        public String proppantType;
        public String wellId;
    }
    
    public class GUIDMapping
    {
        public String wellViewZoneSFID;
        public String wellViewZoneGUID;
        public String WellViewZone;
        public String PVRWellSFID;
        public String PVRWellGUID;
        public String PVRWell;
    }
    
    
    
    
    
    static testMethod void testXmlWriterClassC() {
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            List<GRD_XmlWriter.Borehole> boreholes = new List<GRD_XmlWriter.Borehole>();
            
            // Create an operating district for the opField objects
            Business_Department__c busDep1 = new Business_Department__c();
            busDep1.Name = 'Business Department Test';
            
            insert busDep1;
            
            // Create an operating district for the opField objects
            Operating_District__c opDis1 = new Operating_District__c();
            opDis1.Name = 'Operating District Test';
            opDis1.Business_Department__c = busDep1.id;
            opDis1.GRD_ID__c = '120905';
            
            insert opDis1;
            
            // Create operating field objects for use in location object
            Field__c opField1 = new Field__c();
            opField1.Name = 'Ansell';
            opField1.Operating_District__c = opDis1.id;
            opField1.GRD_ID__c = '4981';
            opField1.AMU_GUID__c = '1122334455';
            
            Field__c opField2 = new Field__c();
            opField2.Name = 'Galloway';
            opField2.Operating_District__c = opDis1.id;
            opField2.GRD_ID__c = '4969';
            opField1.AMU_GUID__c = '6677889911';
            
            Field__c opField3 = new Field__c();
            opField3.Name = 'Kaybob';
            opField3.Operating_District__c = opDis1.id;
            opField3.GRD_ID__c = '6423';
            opField1.AMU_GUID__c = '2233445566';
            
            List<Field__c> opFields = new List<Field__c>();
            opFields.add(opField1);
            opFields.add(opField2);
            opFields.add(opField3);
            
            insert opFields;
            
            // Create location objects to add into borehole object later for UWI Location
            Location__c location1 = new Location__c();
            location1.Name = 'testlocalC1';
            location1.Well_Type__c = 'HZ';
            location1.Surface_Location__c = 'test4';
            location1.Operating_Field_AMU__c = opField1.id;
            
            Location__c location2 = new Location__c();
            location2.Name = 'testlocalC2';
            location2.Well_Type__c = 'HZ';
            location2.Surface_Location__c = 'test4';
            location2.Operating_Field_AMU__c = opField2.id;
            
            Location__c location3 = new Location__c();
            location3.Name = 'testlocalC3';
            location3.Well_Type__c = 'HZ';
            location3.Surface_Location__c = 'test4';
            location3.Operating_Field_AMU__c = opField3.id;
            
            // Create a list of the wells
            List<Location__c> locations = new List<Location__c>();
            locations.add(location1);
            locations.add(location2);
            locations.add(location3);
            
            // Insert the wells into the database
            insert locations;
            
            // Create location objects to add into borehole object later for Target Location
            Location__c locationT1 = new Location__c();
            locationT1.Name = 'testlocalT1';
            locationT1.Operating_Field_AMU__c = opField1.id;
            
            Location__c locationT2 = new Location__c();
            locationT2.Name = 'testlocalT2';
            locationT2.Operating_Field_AMU__c = opField2.id;
            
            Location__c locationT3 = new Location__c();
            locationT3.Name = 'testlocalT3';
            locationT3.Operating_Field_AMU__c = opField3.id;
            
            // Create a list of the wells
            List<Location__c> locationsT = new List<Location__c>();
            locationsT.add(locationT1);
            locationsT.add(locationT2);
            locationsT.add(locationT3);
            
            // Insert the locations into the database
            insert locationsT;
    
            // Create well objects and add them in for use in boreholes
            // For well1
            GRD_Well__c grdWell1 = new GRD_Well__c();
            grdWell1.GRD_GUID__c = 'F67CEBD8E7AD0E76E043D603CC0AD408';
            grdWell1.WellView_GUID__c = '8E8FE2A61B42423FAC590947F491AB29';
            grdWell1.Surface_Location__c = location1.id;
            
            GRD_Well__c grdWell2 = new GRD_Well__c();
            grdWell2.GRD_GUID__c = 'F67CEBD8E7AD0E76E043D603CC0AD405';
            grdWell2.WellView_GUID__c = '8E8FE2A61B42423FAC590947F491AB25';
            
            GRD_Well__c grdWell3 = new GRD_Well__c();
            grdWell3.GRD_GUID__c = 'F67CEBD8E7AD0E76E043D603CC0AD402';
            grdWell3.WellView_GUID__c = '8E8FE2A61B42423FAC590947F491AB22';
            
            // Add the wells to the well reference list
            List<GRD_Well__c> GRDWells = new List<GRD_Well__c>();
            GRDWells.add(grdWell1);
            GRDWells.add(grdWell2);
            GRDWells.add(grdWell3);
            
            // Insert the wells for the well references into the database
            insert GRDWells;
            
            // Create a list of well IDs
            Set<Id> wellIds = new Set<Id>();
               
            // Create a well to put in the list
            GRD_Borehole__c well1 = new GRD_Borehole__c();
            well1.Well_Class__c = 'D';
            well1.Well_Category__c = 'DVLPMNT';
            well1.UWI_Location__c = location1.id;
            well1.Target_Location__c = locationT1.id;
            well1.True_Vertical_Depth__c = 12.000;
            well1.Target_Formation__c = 'BLRV';
            well1.MD__c  = 15.00;
            well1.Horizontal_Length__c = 2.00; 
            well1.Geologist__c = 'Mike Test';
            well1.Working_Interest__c = 71.00;
            well1.GRD_GUID__c = '011034C97C390D2DE053D603CC0A6357';
            well1.WellView_Bore_GUID__c = '011034C97C390D2DE053D603CC0A6357';
            well1.ARC_GIS_GUID__c = '011034C97C390D2DE053D603CC0A635X';
            well1.PVR_Well_GUID__c = '011034C97C390D2DE053D603CC0A635Y';
            well1.Type_Curve_GUID__c = '011034C97C390D2DE053D603CC0A635Z';
            well1.Well__c = grdWell1.id;
            well1.Risked__c = 1;
            well1.Primary_Product__c = 'Test';
            well1.Pool__c = 'Test';
            well1.Strategy__c = 'Test';
            well1.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list
            GRD_Borehole__c well2 = new GRD_Borehole__c();
            well2.Well_Class__c = 'D';
            well2.Well_Category__c = 'DVLPMNT';
            well2.UWI_Location__c = location2.id;
            well2.Target_Location__c = locationT2.id;
            well2.True_Vertical_Depth__c = 12.000;
            well2.Target_Formation__c = 'BLRV';
            well2.MD__c  = 15.00;
            well2.Horizontal_Length__c = 2.00; 
            well2.Geologist__c = 'Bob Test';
            well2.Working_Interest__c = 71.00;
            well2.GRD_GUID__c = '011034C97C390D2DE053D603CC0A6358';
            well2.WellView_Bore_GUID__c =  '011034C97C390D2DE053D603CC0A6358';
            well2.ARC_GIS_GUID__c = '011034C97C390D2DE053D603CC0A635A';
            well2.PVR_Well_GUID__c = '011034C97C390D2DE053D603CC0A635B';
            well2.Type_Curve_GUID__c = '011034C97C390D2DE053D603CC0A635F';            
            well2.Well__c = grdWell2.id;
            well2.Risked__c = 1;
            well2.Primary_Product__c = 'Test';
            well2.Pool__c = 'Test';
            well2.Strategy__c = 'Test';
            well2.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            GRD_Borehole__c well3 = new GRD_Borehole__c();
            well3.Well_Class__c = 'D';
            well3.Well_Category__c = 'DVLPMNT';
            well3.UWI_Location__c = location3.id;
            well3.Target_Location__c = locationT3.id;
            well3.True_Vertical_Depth__c = 12.000;
            well3.Target_Formation__c = 'BLRV';
            well3.MD__c  = 15.00;
            well3.Horizontal_Length__c = 2.00; 
            well3.Geologist__c = 'Roger Test';
            well3.Working_Interest__c = 71.00;
            well3.GRD_GUID__c = '011034C97C390D2DE053D603CC0A6359';
            well3.WellView_Bore_GUID__c = '011034C97C390D2DE053D603CC0A6359';
            well3.ARC_GIS_GUID__c = '011034C97C390D2DE053D603CC0A635C';
            well3.PVR_Well_GUID__c = '011034C97C390D2DE053D603CC0A635D';  
            well3.Type_Curve_GUID__c =  '011034C97C390D2DE053D603CC0A635E';           
            well3.Well__c = grdWell3.id;
            well3.Risked__c = 1;
            well3.Primary_Product__c = 'Test';
            well3.Pool__c = 'Test';
            well3.Strategy__c = 'Test';
            well3.Op_Non_Op__c = 'O';
    
            // Create a list of the wells
            List<GRD_Borehole__c> wells = new List<GRD_Borehole__c>();
            wells.add(well1);
            wells.add(well2);
            wells.add(well3);
            
            // Insert the wells into the database
            insert wells;
            
            // Add well Id to the list
            wellIds.add(well1.Id);
            wellIds.add(well2.Id);
            wellIds.add(well3.Id);
            
            boreholes.add(new GRD_XmlWriter.Borehole());
            boreholes[0].id = well1.id;
            boreholes[0].name = well1.name;
            boreholes[0].status = 'Proposed';
            boreholes[0].grdGuid = well1.GRD_GUID__c;
            boreholes[0].wellviewBoreGuid = well1.WellView_Bore_GUID__c;
            boreholes[0].arcGUID = well1.ARC_GIS_GUID__c;
            boreholes[0].pvrGUID = well1.PVR_Well_GUID__c;
            boreholes[0].typeCurveGUID = well1.Type_Curve_GUID__c;
            boreholes[0].wellClass = 'D';
            boreholes[0].targetFormation = well1.Target_Formation__c;
            boreholes[0].wellType = location1.Well_Type__c;
            boreholes[0].wellCategory = well1.Well_Category__c;
            boreholes[0].geologist = well1.Geologist__c;
            boreholes[0].operatingField = opField1.Name;
            boreholes[0].surfaceLocation  = location1.Name;
            boreholes[0].uwiLocation = locationT1.Name;
            boreholes[0].measuredDepth = well1.MD__c;
            boreholes[0].horizontalLength = well1.Horizontal_Length__c;
            boreholes[0].workingInterest = well1.Working_Interest__c;
            boreholes[0].trueVerticalDepth = well1.True_Vertical_Depth__c;
            boreholes[0].risk = well1.Risked__c;
            boreholes[0].primaryProduct = well1.Primary_Product__c;
            boreholes[0].pool = well1.Pool__c;
            boreholes[0].strategy = well1.Strategy__c;
            boreholes[0].opNonOp = well1.Op_Non_Op__c;
            
            boreholes.add(new GRD_XmlWriter.Borehole());
            boreholes[1].id = well2.id;
            boreholes[1].name = well2.name;
            boreholes[1].status = 'Proposed';
            boreholes[1].grdGuid = well2.GRD_GUID__c;
            boreholes[1].wellviewBoreGuid = well2.WellView_Bore_GUID__c;
            boreholes[1].arcGUID = well2.ARC_GIS_GUID__c;
            boreholes[1].pvrGUID = well2.PVR_Well_GUID__c; 
            boreholes[1].typeCurveGUID = well2.Type_Curve_GUID__c;           
            boreholes[1].wellClass = 'D';
            boreholes[1].targetFormation = well2.Target_Formation__c;
            boreholes[1].wellType = location2.Well_Type__c;
            boreholes[1].wellCategory = well2.Well_Category__c;
            boreholes[1].geologist = well2.Geologist__c;
            boreholes[1].operatingField = opField2.Name;
            boreholes[1].surfaceLocation  = location2.Name;
            boreholes[1].uwiLocation = locationT2.Name;
            boreholes[1].measuredDepth = well2.MD__c;
            boreholes[1].horizontalLength = well2.Horizontal_Length__c;
            boreholes[1].workingInterest = well2.Working_Interest__c;
            boreholes[1].trueVerticalDepth = well2.True_Vertical_Depth__c;
            boreholes[1].risk = well2.Risked__c;
            boreholes[1].primaryProduct = well2.Primary_Product__c;
            boreholes[1].pool = well2.Pool__c;
            boreholes[1].strategy = well2.Strategy__c;
            boreholes[1].opNonOp = well2.Op_Non_Op__c;
            
            boreholes.add(new GRD_XmlWriter.Borehole());
            boreholes[2].id = well3.id;
            boreholes[2].name = well3.name;
            boreholes[2].status = 'Proposed';
            boreholes[2].grdGuid = well3.GRD_GUID__c;
            boreholes[2].wellviewBoreGuid = well3.WellView_Bore_GUID__c;
            boreholes[2].arcGUID = well3.ARC_GIS_GUID__c;
            boreholes[2].pvrGUID = well3.PVR_Well_GUID__c;  
            boreholes[2].typeCurveGUID = well3.Type_Curve_GUID__c;                 
            boreholes[2].wellClass = 'D';
            boreholes[2].targetFormation = well3.Target_Formation__c;
            boreholes[2].wellType = location3.Well_Type__c;
            boreholes[2].wellCategory = well3.Well_Category__c;
            boreholes[2].geologist = well3.Geologist__c;
            boreholes[2].operatingField = opField3.Name;
            boreholes[2].surfaceLocation  = location3.Name;
            boreholes[2].uwiLocation = locationT3.Name;
            boreholes[2].measuredDepth = well3.MD__c;
            boreholes[2].horizontalLength = well3.Horizontal_Length__c;
            boreholes[2].workingInterest = well3.Working_Interest__c;
            boreholes[2].trueVerticalDepth = well3.True_Vertical_Depth__c;
            boreholes[2].risk = well3.Risked__c;
            boreholes[2].primaryProduct = well3.Primary_Product__c;
            boreholes[2].pool = well3.Pool__c;
            boreholes[2].strategy = well3.Strategy__c;
            boreholes[2].opNonOp = well3.Op_Non_Op__c;
            
            // Create completions and add them in
            // For well1
            Class_C_Well_Completion__c completion1 = new Class_C_Well_Completion__c();
            completion1.CategoryIsolationCode__c = 'Ball Drop';
            completion1.CompletionFluid__c = 'H20 - Gelled Water';
            completion1.NumberOfFracs__c = 234;
            completion1.Proppant_Size__c='1';
            completion1.Proppant_Type__c='test';
            completion1.TProppantPerFrac__c = 123456;
            completion1.Well__c = well1.Id;
            // For well1
            Class_C_Well_Completion__c completion2 = new Class_C_Well_Completion__c();
            completion2.CategoryIsolationCode__c = 'Ball Drop';
            completion2.CompletionFluid__c = 'H20 - Gelled Water';
            completion2.NumberOfFracs__c = 444;
            completion2.TProppantPerFrac__c = 654321;
            completion2.Proppant_Size__c='1';
            completion2.Proppant_Type__c='test';
            completion2.Well__c = well1.Id;
            
            // For well3
            Class_C_Well_Completion__c completion3 = new Class_C_Well_Completion__c();
            completion3.CategoryIsolationCode__c = 'Ball Drop';
            completion3.CompletionFluid__c = 'H20 - Gelled Water';
            completion3.NumberOfFracs__c = 111;
            completion3.TProppantPerFrac__c = 111111;
            completion3.Proppant_Size__c='1';
            completion3.Proppant_Type__c='test';
            completion3.Well__c = well3.Id;
            
            // Add the completions to the completion list
            List<Class_C_Well_Completion__c> completions = new List<Class_C_Well_Completion__c>();
            completions.add(completion1);
            completions.add(completion2);
            completions.add(completion3);
            
            // Insert the completions for the well into the database
            insert completions;
            
            // Create a user email
            String userEmail = 'bobbytester@huskyenergy.com';
            
            System.debug('Generating XML for class C well update');
            // Call the XML Writer class and output it to console as a string
            System.debug(GRD_XmlWriter.generateClassCXML(boreholes, wellIds, userEmail).toXmlString());
            
            String wellJSON = JSON.serialize(boreholes[0]);
            
            GRDWellInventoryController.saveBorehole(wellJSON);
            
            new GRDWellInventoryController().getSalesforceBaseURL();
            new GRDWellInventoryController().getGrdDashboardURL();
            new GRDWellInventoryController().getLoggedInUserName();
            GRDWellInventoryController.getOperatingFieldRecordTypeId();
            
            String wellJSON2 = JSON.serialize(boreholes);
            GRD_XmlWriter.processClassCsUpdated(wellJSON2, 'GRD');
        }
    }

    static testMethod void testXmlWriterClassD() {
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        
        System.runAs(grdIntegration)
        {
            // Create a list of well IDs
            Set<Id> wellIds = new Set<Id>();
            
            // Create a well to put in the list
            Class_D_Well__c well1 = new Class_D_Well__c();
            well1.Well_Type__c = 'HZ';
            well1.Well_Class__c = 'D';
            well1.Well_Category__c = 'DVLPMNT';
            well1.UWI_Location__c = 'testlocal1';
            well1.True_Vertical_Depth__c = 12.000;
            well1.Target_Formation__c = 'BLRV';
            well1.Surface_Location__c = 'test1';
            well1.Operating_Field__c = 'Ansell';
            well1.Measured_Depth__c  = 15.00;
            well1.Horizontal_Length__c = 2.00; 
            well1.Geologist__c = 'Mike Test';
            well1.Working_Interest__c = 71.00;
            well1.Associated_Well__c = 'testlocal3';
            well1.Risked__c = 1;
            well1.Primary_Product__c = 'Test';
            well1.Pool__c = 'Test';
            well1.Strategy__c = 'Test';
            well1.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list
            Class_D_Well__c well2 = new Class_D_Well__c();
            well2.Well_Type__c = 'HZ';
            well2.Well_Class__c = 'D';
            well2.Well_Category__c = 'DVLPMNT';
            well2.UWI_Location__c = 'testlocal2';
            well2.True_Vertical_Depth__c = 12.000;
            well2.Target_Formation__c = 'BLRV';
            well2.Surface_Location__c = 'test2';
            well2.Operating_Field__c = 'Ansell';
            well2.Measured_Depth__c  = 15.00;
            well2.Horizontal_Length__c = 2.00; 
            well2.Geologist__c = 'Bob Test';
            well2.Working_Interest__c = 71.00;
            well2.Target_Location__c = 'testargetlocation';
            well2.Associated_Well__c = 'testlocal1';
            well2.Risked__c = 1;
            well2.Primary_Product__c = 'Test';
            well2.Pool__c = 'Test';
            well2.Strategy__c = 'Test';
            well2.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well3 = new Class_D_Well__c();
            well3.Well_Type__c = 'HZ';
            well3.Well_Class__c = 'D';
            well3.Well_Category__c = 'DVLPMNT';
            well3.UWI_Location__c = 'testlocal3';
            well3.True_Vertical_Depth__c = 12.000;
            well3.Target_Formation__c = 'BLRV';
            well3.Surface_Location__c = 'test3';
            well3.Operating_Field__c = 'Ansell';
            well3.Measured_Depth__c  = 15.00;
            well3.Horizontal_Length__c = 2.00; 
            well3.Geologist__c = 'Roger Test';
            well3.Working_Interest__c = 71.00;
            well3.Associated_Well__c = 'testlocal2';
            well3.Risked__c = 1;
            well3.Primary_Product__c = 'Test';
            well3.Pool__c = 'Test';
            well3.Strategy__c = 'Test';
            well3.Op_Non_Op__c = 'O';
            
            // End cycle test
            
            // Start with blanks
            // Create a well to put in the list 
            Class_D_Well__c well4 = new Class_D_Well__c();
            well4.Well_Type__c = 'HZ';
            well4.Well_Class__c = 'D';
            well4.Well_Category__c = 'DVLPMNT';
            well4.UWI_Location__c = 'testlocal4';
            well4.True_Vertical_Depth__c = 12.000;
            well4.Target_Formation__c = 'BLRV';
            well4.Surface_Location__c = 'test3';
            well4.Operating_Field__c = 'Ansell';
            well4.Measured_Depth__c  = 15.00;
            well4.Horizontal_Length__c = 2.00; 
            well4.Geologist__c = 'Roger Test';
            well4.Working_Interest__c = 71.00;
            well4.Associated_Well__c = 'testlocal5';
            well4.Risked__c = 1;
            well4.Primary_Product__c = 'Test';
            well4.Pool__c = 'Test';
            well4.Strategy__c = 'Test';
            well4.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well5 = new Class_D_Well__c();
            well5.Well_Type__c = 'HZ';
            well5.Well_Class__c = 'D';
            well5.Well_Category__c = 'DVLPMNT';
            well5.UWI_Location__c = 'testlocal5';
            well5.True_Vertical_Depth__c = 12.000;
            well5.Target_Formation__c = 'BLRV';
            well5.Surface_Location__c = 'test3';
            well5.Operating_Field__c = 'Ansell';
            well5.Measured_Depth__c  = 15.00;
            well5.Horizontal_Length__c = 2.00; 
            well5.Geologist__c = 'Roger Test';
            well5.Working_Interest__c = 71.00;
            well5.Risked__c = 1;
            well5.Primary_Product__c = 'Test';
            well5.Pool__c = 'Test';
            well5.Strategy__c = 'Test';
            well5.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well6 = new Class_D_Well__c();
            well6.Well_Type__c = 'HZ';
            well6.Well_Class__c = 'D';
            well6.Well_Category__c = 'DVLPMNT';
            well6.UWI_Location__c = 'testlocal6';
            well6.True_Vertical_Depth__c = 12.000;
            well6.Target_Formation__c = 'BLRV';
            well6.Surface_Location__c = 'test3';
            well6.Operating_Field__c = 'Ansell';
            well6.Measured_Depth__c  = 15.00;
            well6.Horizontal_Length__c = 2.00; 
            well6.Geologist__c = 'Roger Test';
            well6.Working_Interest__c = 71.00;
            well6.Associated_Well__c = 'testlocal5';
            well6.Risked__c = 1;
            well6.Primary_Product__c = 'Test';
            well6.Pool__c = 'Test';
            well6.Strategy__c = 'Test';
            well6.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well7 = new Class_D_Well__c();
            well7.Well_Type__c = 'HZ';
            well7.Well_Class__c = 'D';
            well7.Well_Category__c = 'DVLPMNT';
            well7.UWI_Location__c = 'testlocal7';
            well7.True_Vertical_Depth__c = 12.000;
            well7.Target_Formation__c = 'BLRV';
            well7.Surface_Location__c = 'test3';
            well7.Operating_Field__c = 'Ansell';
            well7.Measured_Depth__c  = 15.00;
            well7.Horizontal_Length__c = 2.00; 
            well7.Geologist__c = 'Roger Test';
            well7.Working_Interest__c = 71.00;
            well7.Associated_Well__c = 'testlocal22';
            well7.Risked__c = 1;
            well7.Primary_Product__c = 'Test';
            well7.Pool__c = 'Test';
            well7.Strategy__c = 'Test';
            well7.Op_Non_Op__c = 'O';
    
            // Create a well to put in the list 
            Class_D_Well__c well8 = new Class_D_Well__c();
            well8.Well_Type__c = 'HZ';
            well8.Well_Class__c = 'D';
            well8.Well_Category__c = 'DVLPMNT';
            well8.UWI_Location__c = 'testlocal8';
            well8.True_Vertical_Depth__c = 12.000;
            well8.Target_Formation__c = 'BLRV';
            well8.Surface_Location__c = 'test3';
            well8.Operating_Field__c = 'Ansell';
            well8.Measured_Depth__c  = 15.00;
            well8.Horizontal_Length__c = 2.00; 
            well8.Geologist__c = 'Roger Test';
            well8.Working_Interest__c = 71.00;
            well8.Associated_Well__c = 'testlocal21';
            well8.Risked__c = 1;
            well8.Primary_Product__c = 'Test';
            well8.Pool__c = 'Test';
            well8.Strategy__c = 'Test';
            well8.Op_Non_Op__c = 'O';
    
            // Create a well to put in the list 
            Class_D_Well__c well9 = new Class_D_Well__c();
            well9.Well_Type__c = 'HZ';
            well9.Well_Class__c = 'D';
            well9.Well_Category__c = 'DVLPMNT';
            well9.UWI_Location__c = 'testlocal9';
            well9.True_Vertical_Depth__c = 12.000;
            well9.Target_Formation__c = 'BLRV';
            well9.Surface_Location__c = 'test3';
            well9.Operating_Field__c = 'Ansell';
            well9.Measured_Depth__c  = 15.00;
            well9.Horizontal_Length__c = 2.00; 
            well9.Geologist__c = 'Roger Test';
            well9.Working_Interest__c = 71.00;
            well9.Associated_Well__c = 'testlocal21';
            well9.Risked__c = 1;
            well9.Primary_Product__c = 'Test';
            well9.Pool__c = 'Test';
            well9.Strategy__c = 'Test';
            well9.Op_Non_Op__c = 'O';
            
            
            // Create a list of the wells
            List<Class_D_Well__c> wells = new List<Class_D_Well__c>();
            wells.add(well1);
            wells.add(well2);
            wells.add(well3);
            wells.add(well4);
            wells.add(well5);
            wells.add(well6);
            wells.add(well7);
            wells.add(well8);
            wells.add(well9);
            
            // Insert the wells into the database
            insert wells;
            
            // Add well Id to the list
            wellIds.add(well4.Id);
            wellIds.add(well5.Id);
            wellIds.add(well2.Id);
            wellIds.add(well1.Id);
            wellIds.add(well9.Id);
            wellIds.add(well7.Id);
            wellIds.add(well3.Id);
            wellIds.add(well6.Id);
            wellIds.add(well8.Id);
            
            // Create completions and add them in
            // For well1
            Class_D_Well_Completion__c completion1 = new Class_D_Well_Completion__c();
            completion1.CategoryIsolationCode__c = 'Ball Drop';
            completion1.CompletionFluid__c = 'H20 - Gelled Water';
            completion1.NumberOfFracs__c = 234;
            completion1.TProppantPerFrac__c = 123456;
            completion1.Proppant_Size__c='1';
            completion1.Proppant_Type__c='test';
            completion1.Class_D_Well__c = well1.Id;
            // For well1
            Class_D_Well_Completion__c completion2 = new Class_D_Well_Completion__c();
            completion2.CategoryIsolationCode__c = 'Ball Drop';
            completion2.CompletionFluid__c = 'H20 - Gelled Water';
            completion2.NumberOfFracs__c = 444;
            completion2.TProppantPerFrac__c = 654321;
            completion2.Proppant_Size__c='1';
            completion2.Proppant_Type__c='test';
            completion2.Class_D_Well__c = well1.Id;
            
            // For well3
            Class_D_Well_Completion__c completion3 = new Class_D_Well_Completion__c();
            completion3.CategoryIsolationCode__c = 'Ball Drop';
            completion3.CompletionFluid__c = 'H20 - Gelled Water';
            completion3.NumberOfFracs__c = 111;
            completion3.TProppantPerFrac__c = 111111;
            completion3.Proppant_Size__c='1';
            completion3.Proppant_Type__c='test';
            completion3.Class_D_Well__c = well3.Id;
            
            // Add the completions to the completion list
            List<Class_D_Well_Completion__c> completions = new List<Class_D_Well_Completion__c>();
            completions.add(completion1);
            completions.add(completion2);
            completions.add(completion3);
            
            // Insert the completions for the well into the database
            insert completions;
            
            // Create an approver
            User approver = [SELECT id, firstName, lastName, email, Name FROM User WHERE lastName = 'Admin' LIMIT 1];
            approver.email = 'bobbytester@gothirdwave.com';
            
            // Create a user email
            String userEmail = approver.email;
            // Set the boolean isApproved to be true
            Boolean isApproved = true;
            
            // Call the XML Writer class and output it to console as a string
            //System.debug(GRD_XmlWriter.generateClassDXML(wells, approver, isApproved, userEmail).toXmlString());
            
            // Make a well list for the emailWellApprover method
            List<Class_D_Well__c> wellList = new List<Class_D_Well__c>();
            wellList.add(well1);
            wellList.add(well2);
            wellList.add(well3);
            
            // Make the approvers a list
            List<User> approvers = new List<User>();
            approvers.add(approver);
            approvers.add(approver);
            
            // Send an email to the approver for an approval email
            GRD_XMLWriter.emailWellApprover(approvers, wellList, 'approval');
            
            // This well list only contains one item to simulate approved, recalled and rejected emails
            List<Class_D_Well__c> wellList2 = new List<Class_D_Well__c>();
            wellList2.add(well1);
            
            // Approved, rejected and recalled emails for singular wells
            GRD_XMLWriter.emailWellApprover(approvers, wellList2, 'approved');
            GRD_XMLWriter.emailWellApprover(approvers, wellList2, 'rejected');
            GRD_XMLWriter.emailWellApprover(approvers, wellList2, 'recalled');
        }
    }
    
    static testMethod void testProcessClassDForRecall() {
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        // Create an operating district for the opField objects
        Business_Department__c busDep1 = new Business_Department__c();
        busDep1.Name = 'Business Department Test';
        
        insert busDep1;
        
        // Create an operating district for the opField objects
        Operating_District__c opDis1 = new Operating_District__c();
        opDis1.Name = 'Operating District Test';
        opDis1.Business_Department__c = busDep1.id;
        opDis1.GRD_ID__c = '220905';
        
        insert opDis1;
        
        // Create operating field objects for use in location object
        Field__c opField1 = new Field__c();
        opField1.Name = 'Ansell';
        opField1.Operating_District__c = opDis1.id;
        opField1.GRD_ID__c = '8981';
        opField1.AMU_GUID__c = '112233445566';
        
        insert opField1;          
        
        System.runAs(grdIntegration)
        {
            // Create a list of well IDs
            Set<Id> wellIds = new Set<Id>();
            
            // Create a well to put in the list
            Class_D_Well__c well1 = new Class_D_Well__c();
            well1.Well_Type__c = 'HZ';
            well1.Well_Class__c = 'D';
            well1.Well_Category__c = 'DVLPMNT';
            well1.UWI_Location__c = 'testlocal1';
            well1.True_Vertical_Depth__c = 12.000;
            well1.Target_Formation__c = 'BLRV';
            well1.Surface_Location__c = 'test1';
            well1.Operating_Field__c = 'Ansell';
            well1.Measured_Depth__c  = 15.00;
            well1.Horizontal_Length__c = 2.00; 
            well1.Geologist__c = 'Mike Test';
            well1.Working_Interest__c = 71.00;
            well1.Associated_Well__c = 'testlocal3';
            well1.Risked__c = 1;
            well1.Primary_Product__c = 'Test';
            well1.Pool__c = 'Test';
            well1.Strategy__c = 'Test';
            well1.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list
            Class_D_Well__c well2 = new Class_D_Well__c();
            well2.Well_Type__c = 'HZ';
            well2.Well_Class__c = 'D';
            well2.Well_Category__c = 'DVLPMNT';
            well2.UWI_Location__c = 'testlocal2';
            well2.True_Vertical_Depth__c = 12.000;
            well2.Target_Formation__c = 'BLRV';
            well2.Surface_Location__c = 'test2';
            well2.Operating_Field__c = 'Ansell';
            well2.Measured_Depth__c  = 15.00;
            well2.Horizontal_Length__c = 2.00; 
            well2.Geologist__c = 'Bob Test';
            well2.Working_Interest__c = 71.00;
            well2.Target_Location__c = 'testargetlocation';
            well2.Associated_Well__c = 'testlocal1';
            well2.Risked__c = 1;
            well2.Primary_Product__c = 'Test';
            well2.Pool__c = 'Test';
            well2.Strategy__c = 'Test';
            well2.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well3 = new Class_D_Well__c();
            well3.Well_Type__c = 'HZ';
            well3.Well_Class__c = 'D';
            well3.Well_Category__c = 'DVLPMNT';
            well3.UWI_Location__c = 'testlocal3';
            well3.True_Vertical_Depth__c = 12.000;
            well3.Target_Formation__c = 'BLRV';
            well3.Surface_Location__c = 'test3';
            well3.Operating_Field__c = 'Ansell';
            well3.Measured_Depth__c  = 15.00;
            well3.Horizontal_Length__c = 2.00; 
            well3.Geologist__c = 'Roger Test';
            well3.Working_Interest__c = 71.00;
            well3.Associated_Well__c = 'testlocal2';
            well3.Risked__c = 1;
            well3.Primary_Product__c = 'Test';
            well3.Pool__c = 'Test';
            well3.Strategy__c = 'Test';
            well3.Op_Non_Op__c = 'O';
            
            // End cycle test
            
            // Start with blanks
            // Create a well to put in the list 
            Class_D_Well__c well4 = new Class_D_Well__c();
            well4.Well_Type__c = 'HZ';
            well4.Well_Class__c = 'D';
            well4.Well_Category__c = 'DVLPMNT';
            well4.UWI_Location__c = 'testlocal4';
            well4.True_Vertical_Depth__c = 12.000;
            well4.Target_Formation__c = 'BLRV';
            well4.Surface_Location__c = 'test3';
            well4.Operating_Field__c = 'Ansell';
            well4.Measured_Depth__c  = 15.00;
            well4.Horizontal_Length__c = 2.00; 
            well4.Geologist__c = 'Roger Test';
            well4.Working_Interest__c = 71.00;
            well4.Associated_Well__c = 'testlocal5';
            well4.Risked__c = 1;
            well4.Primary_Product__c = 'Test';
            well4.Pool__c = 'Test';
            well4.Strategy__c = 'Test';
            well4.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well5 = new Class_D_Well__c();
            well5.Well_Type__c = 'HZ';
            well5.Well_Class__c = 'D';
            well5.Well_Category__c = 'DVLPMNT';
            well5.UWI_Location__c = 'testlocal5';
            well5.True_Vertical_Depth__c = 12.000;
            well5.Target_Formation__c = 'BLRV';
            well5.Surface_Location__c = 'test3';
            well5.Operating_Field__c = 'Ansell';
            well5.Measured_Depth__c  = 15.00;
            well5.Horizontal_Length__c = 2.00; 
            well5.Geologist__c = 'Roger Test';
            well5.Working_Interest__c = 71.00;
            well5.Risked__c = 1;
            well5.Primary_Product__c = 'Test';
            well5.Pool__c = 'Test';
            well5.Strategy__c = 'Test';
            well5.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well6 = new Class_D_Well__c();
            well6.Well_Type__c = 'HZ';
            well6.Well_Class__c = 'D';
            well6.Well_Category__c = 'DVLPMNT';
            well6.UWI_Location__c = 'testlocal6';
            well6.True_Vertical_Depth__c = 12.000;
            well6.Target_Formation__c = 'BLRV';
            well6.Surface_Location__c = 'test3';
            well6.Operating_Field__c = 'Ansell';
            well6.Measured_Depth__c  = 15.00;
            well6.Horizontal_Length__c = 2.00; 
            well6.Geologist__c = 'Roger Test';
            well6.Working_Interest__c = 71.00;
            well6.Associated_Well__c = 'testlocal5';
            well6.Risked__c = 1;
            well6.Primary_Product__c = 'Test';
            well6.Pool__c = 'Test';
            well6.Strategy__c = 'Test';
            well6.Op_Non_Op__c = 'O';
            
            // Create a well to put in the list 
            Class_D_Well__c well7 = new Class_D_Well__c();
            well7.Well_Type__c = 'HZ';
            well7.Well_Class__c = 'D';
            well7.Well_Category__c = 'DVLPMNT';
            well7.UWI_Location__c = 'testlocal7';
            well7.True_Vertical_Depth__c = 12.000;
            well7.Target_Formation__c = 'BLRV';
            well7.Surface_Location__c = 'test3';
            well7.Operating_Field__c = 'Ansell';
            well7.Measured_Depth__c  = 15.00;
            well7.Horizontal_Length__c = 2.00; 
            well7.Geologist__c = 'Roger Test';
            well7.Working_Interest__c = 71.00;
            well7.Associated_Well__c = 'testlocal22';
            well7.Risked__c = 1;
            well7.Primary_Product__c = 'Test';
            well7.Pool__c = 'Test';
            well7.Strategy__c = 'Test';
            well7.Op_Non_Op__c = 'O';
    
            // Create a well to put in the list 
            Class_D_Well__c well8 = new Class_D_Well__c();
            well8.Well_Type__c = 'HZ';
            well8.Well_Class__c = 'D';
            well8.Well_Category__c = 'DVLPMNT';
            well8.UWI_Location__c = 'testlocal8';
            well8.True_Vertical_Depth__c = 12.000;
            well8.Target_Formation__c = 'BLRV';
            well8.Surface_Location__c = 'test3';
            well8.Operating_Field__c = 'Ansell';
            well8.Measured_Depth__c  = 15.00;
            well8.Horizontal_Length__c = 2.00; 
            well8.Geologist__c = 'Roger Test';
            well8.Working_Interest__c = 71.00;
            well8.Associated_Well__c = 'testlocal21';
            well8.Risked__c = 1;
            well8.Primary_Product__c = 'Test';
            well8.Pool__c = 'Test';
            well8.Strategy__c = 'Test';
            well8.Op_Non_Op__c = 'O';
    
            // Create a well to put in the list 
            Class_D_Well__c well9 = new Class_D_Well__c();
            well9.Well_Type__c = 'HZ';
            well9.Well_Class__c = 'D';
            well9.Well_Category__c = 'DVLPMNT';
            well9.UWI_Location__c = 'testlocal9';
            well9.True_Vertical_Depth__c = 12.000;
            well9.Target_Formation__c = 'BLRV';
            well9.Surface_Location__c = 'test3';
            well9.Operating_Field__c = 'Ansell';
            well9.Measured_Depth__c  = 15.00;
            well9.Horizontal_Length__c = 2.00; 
            well9.Geologist__c = 'Roger Test';
            well9.Working_Interest__c = 71.00;
            well9.Associated_Well__c = 'testlocal21';
            well9.Risked__c = 1;
            well9.Primary_Product__c = 'Test';
            well9.Pool__c = 'Test';
            well9.Strategy__c = 'Test';
            well9.Op_Non_Op__c = 'O';
            
            
            // Create a list of the wells
            List<Class_D_Well__c> wells = new List<Class_D_Well__c>();
            wells.add(well1);
            wells.add(well2);
            wells.add(well3);
            wells.add(well4);
            wells.add(well5);
            wells.add(well6);
            wells.add(well7);
            wells.add(well8);
            wells.add(well9);
            
            // Insert the wells into the database
            insert wells;
            
            // Add well Id to the list
            wellIds.add(well4.Id);
            wellIds.add(well5.Id);
            wellIds.add(well2.Id);
            wellIds.add(well1.Id);
            wellIds.add(well9.Id);
            wellIds.add(well7.Id);
            wellIds.add(well3.Id);
            wellIds.add(well6.Id);
            wellIds.add(well8.Id);
            
            // Create completions and add them in
            // For well1
            Class_D_Well_Completion__c completion1 = new Class_D_Well_Completion__c();
            completion1.CategoryIsolationCode__c = 'Ball Drop';
            completion1.CompletionFluid__c = 'H20 - Gelled Water';
            completion1.NumberOfFracs__c = 234;
            completion1.TProppantPerFrac__c = 123456;
            completion1.Proppant_Size__c='1';
            completion1.Proppant_Type__c='test';
            completion1.Class_D_Well__c = well1.Id;
            // For well1
            Class_D_Well_Completion__c completion2 = new Class_D_Well_Completion__c();
            completion2.CategoryIsolationCode__c = 'Ball Drop';
            completion2.CompletionFluid__c = 'H20 - Gelled Water';
            completion2.NumberOfFracs__c = 444;
            completion2.TProppantPerFrac__c = 654321;
            completion2.Proppant_Size__c='1';
            completion2.Proppant_Type__c='test';
            completion2.Class_D_Well__c = well1.Id;
            
            // For well3
            Class_D_Well_Completion__c completion3 = new Class_D_Well_Completion__c();
            completion3.CategoryIsolationCode__c = 'Ball Drop';
            completion3.CompletionFluid__c = 'H20 - Gelled Water';
            completion3.NumberOfFracs__c = 111;
            completion3.TProppantPerFrac__c = 111111;
            completion3.Proppant_Size__c='1';
            completion3.Proppant_Type__c='test';
            completion3.Class_D_Well__c = well3.Id;
            
            // Add the completions to the completion list
            List<Class_D_Well_Completion__c> completions = new List<Class_D_Well_Completion__c>();
            completions.add(completion1);
            completions.add(completion2);
            completions.add(completion3);
            
            // Insert the completions for the well into the database
            insert completions;
            
            // Make a well list for the emailWellApprover method
            List<Class_D_Well__c> wellList = new List<Class_D_Well__c>();
            wellList.add(well1);
            wellList.add(well2);
            wellList.add(well3);
            
            // This well list only contains one item to simulate approved, recalled and rejected emails
            List<Class_D_Well__c> wellList2 = new List<Class_D_Well__c>();
            wellList2.add(well1);
            
            // Create borehole and completion class objects matching the above
            List<Borehole> bores = new List<Borehole>();
            bores.add(new Borehole());
            bores[0].id = well1.id;
            bores[0].name = well1.name;
            bores[0].status = 'Proposed';
            bores[0].wellClass = well1.Well_Class__c;
            bores[0].targetFormation = well1.Target_Formation__c;
            bores[0].wellType = well1.Well_Type__c;
            bores[0].wellCategory = well1.Well_Category__c;
            bores[0].geologist = well1.Geologist__c;
            bores[0].operatingField = well1.Operating_Field__c;
            bores[0].surfaceLocation = well1.Surface_Location__c;
            bores[0].uwiLocation = well1.UWI_Location__c;
            bores[0].measuredDepth = well1.Measured_Depth__c;
            bores[0].horizontalLength = well1.Horizontal_Length__c;
            bores[0].workingInterest = well1.Working_Interest__c;
            bores[0].trueVerticalDepth = well1.True_Vertical_Depth__c;
            bores[0].risk = well1.Risked__c;
            bores[0].primaryProduct = well1.Primary_Product__c;
            bores[0].pool = well1.Pool__c;
            bores[0].strategy = well1.Strategy__c;
            bores[0].opNonOp = well1.Op_Non_Op__c;
            
            String wellJSON = JSON.serialize(bores);
            
            GRD_XmlWriter.processClassDsSubmittedForApproval(wellJSON);
            GRD_XmlWriter.processClassDsSubmittedForRecall(wellJSON);
            GRD_XmlWriter.processClassDsSubmittedForRejection(wellJSON);
            GRD_XmlWriter.processClassDsAppoved(wellJSON,'GRD');
            
            
            
            
            GRDWellInventoryController.addApprovalHistory(wellJSON,'test');
            GRDWellInventoryController.rejectClassDWell(wellJSON);
            GRDWellInventoryController.commitClassDToDatabase(wellJSON);
            GRDWellInventoryController.recallClassDFromApproval(wellJSON);
            GRDWellInventoryController.submitClassDForApproval(wellJSON);
            GRDWellInventoryController.getUserAccessLevel();
            
            GRDWellInventoryController.deleteClassDCompletion(completion1.id);
            
            GRDWellInventoryController.addNewClassDWell('1234567890',wellJSON);
            
            GRDWellInventoryController.deleteClassDWell(well1.id);
            
            GRDWellInventoryController.saveClassDWell(wellJSON);
            
            GRDWellInventoryController.findSObjects('test','SELECT Id FROM Location__c WHERE Name ','Surface');
            
            GRDWellInventoryController.findSObjects('test','SELECT Id FROM Location__c WHERE Name ','Operating Field');
        }
    }
}